import { getToken, removeToken, setToken } from '@/utils/auth';
import { user } from '@/store/mutation-types';
import { resetRouter } from '@/router';

const getDefaultSate = () => {
  return {
    token: getToken(),
    name: 'teacher',
    userType: ''
  };
};

const state = getDefaultSate();

const mutations = {
  [user.RESET_STATE]: state => {
    Object.assign(state, getDefaultSate());
  },
  [user.SET_TOKEN]: (state, token) => {
    state.token = token;
  },
  [user.SET_USER_TYPE]: (state, userType) => {
    state.userType = userType;
  }
};

const actions = {
  // 登录
  login({ commit }, userInfo) {
    const {
      loginForm: { username, password },
      userType
    } = userInfo;
    return new Promise(reslove => {
      if (Boolean(username) && Boolean(password)) {
        setToken(`token-${username}-${password}`);
        commit(user.SET_USER_TYPE, userType);
        commit(user.SET_TOKEN, `token-${username}-${password}`);
        reslove();
      }
    });
  },

  // 用户退出
  signOut({ commit }) {
    return new Promise(resolve => {
      removeToken();
      resetRouter();
      commit(user.RESET_STATE);
      resolve();
    });
  },

  removeToken({ commit }) {
    return new Promise(reslove => {
      removeToken();
      commit(user.RESET_STATE);
      reslove();
    });
  }
};

export default {
  namespaced: true,
  state,
  mutations,
  actions
};
